package be.jeffcheasey88.peeratcode.parser.java.operation;

import java.util.function.Function;

import be.jeffcheasey88.peeratcode.parser.Token;
import be.jeffcheasey88.peeratcode.parser.java.JavaElement;
import be.jeffcheasey88.peeratcode.parser.java.Value;

public class ForeachOperation extends OperationBag{
	
	private Token type;
	private Token name;
	private Value iterator;
	
	public ForeachOperation(Token type, Token name, Value iterator){
		super();
		
		this.type = type;
		this.name = name;
		this.iterator = iterator;
	}
	
	public Token getType(){
		return this.type;
	}
	
	public Token getName(){
		return this.name;
	}
	
	public Value getIterator(){
		return this.iterator;
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder){
		if(finder.apply(iterator)) return (E)iterator;
		return super.find(finder);
	}
}
